#ifndef _COSINE_
#define _COSINE_

#include "types.h"
#include <algorithm>
#include <limits>

inline double square(double value) {
  return value * value;
}

inline double squared_l2_distance(Vector first, Vector second) {
  return square(first.x() - second.x()) + square(first.y() - second.y()) + square(first.z() - second.z());
}

inline double cosine_similarity(Vector first, Vector second) {
  return (first.x()*second.x()+first.y()*second.y()+first.z()*second.z())/std::max(std::sqrt(first.squared_length()*second.squared_length()), 1e-5);
}

inline double calculate_3d_probability_cosine(Vector value, Vector mean, double std_) {
    double std_crop = std::max(std_, 1e-2);
    double frac = 1.0 / (std_crop * sqrt(2 * M_PI));
    double power = -0.5 * square(1-std::abs(cosine_similarity(value, mean))) / (std_crop*std_crop);
    double ret = frac * exp(power);
    return ret;
}


#endif