#ifndef PARAMETERS_H
#define PARAMETERS_H

#include <string>

class Parameters
{
public:
    Parameters();

    ~Parameters();

    void reset();

	void reset_detection();

    void reset_transform();

public:
    /** Level 0 : user inputs */

	int verbose_level;

    std::string path_input_pcd;
	std::string path_input_mesh;

    // For the case where input is a pair of pcds
    std::string path_input_source_pcd;
    std::string path_input_target_pcd;

	std::string path_output_dir;
	std::string suffix;

    /** Level 1 : Shape detection parameters */
    double detection_epsilon_ratio;
    double detection_normal_threshold;
    int detection_knn;
    int detection_min_points;

    /** Level 1 : Transformation parameters */
    double transform_x_angle;
    double transform_y_angle;
    double transform_z_angle;
    double transform_x_offset;
    double transform_y_offset;
    double transform_z_offset;
    double transform_scale;

    /** Level 2: Registration */
    size_t nbq;
    bool scale_est;
};

#endif // PARAMETERS_H
