#ifndef _DETECTION_
#define _DETECTION_
#if defined (_MSC_VER) && !defined (_WIN64)
#pragma warning(disable:4244) // boost::number_distance::distance()
                              // converts 64 to 32 bits integers
#endif

#include "types.h"
#include "parameters.h"


namespace RegionGrowing
{
    class Cloud_segmentation;
}

namespace Shape_detection {

std::shared_ptr<RegionGrowing::Cloud_segmentation> detect_shape(const Pwn_vector& points, 
                const Parameters &params, 
                Pwn_vector& points_filtered,
                std::vector<std::vector<Point3>>& alpha_shapes,
                std::vector<Vector>& normal_alpha_shape,
                double& average_spacing, 
                bool save);

void compute_alpha_shapes(const RegionGrowing::Cloud_segmentation& C, 
                std::vector<std::vector<Point3>>& alpha_shapes,
                std::vector<Vector>& normal_alpha_shape);

void compute_alpha_shapes_anchors(const RegionGrowing::Cloud_segmentation& C, 
                std::vector<Point3>& anchors, 
                double search_radius, 
                std::vector<std::vector<Point3>>& alpha_shapes,
                std::vector<Vector>& normal_alpha_shape);
   
}

#endif // _DETECTION_