#pragma once

#include <iostream>
#include <string.h>
#include "types.h"
#include "parameters.h"


class Args {
public:
	Parameters* params;
	
public:
    Args(Parameters* params_) : params(params_)
	{reset();}

    ~Args(){}

    void reset(){
		params->reset();
	}
	
	
	bool parse(int argc, char *argv[])
	{
		if (argc == 1) {
			help(); return false;
		}
		int r = 1;
		while (r < argc) {
			if (!strcmp(argv[r], "--input-pcd") && r + 1 < argc) {
				params->path_input_pcd = argv[r + 1];
				r += 2;
			}
			else if (!strcmp(argv[r], "--input-mesh") && r + 1 < argc) {
				params->path_input_mesh = argv[r + 1];
				r += 2;
			}
			else if (!strcmp(argv[r], "--input-source") && r + 1 < argc) {
				params->path_input_source_pcd = argv[r + 1];
				r += 2;
			}
			else if (!strcmp(argv[r], "--input-target") && r + 1 < argc) {
				params->path_input_target_pcd = argv[r + 1];
				r += 2;
			}
			else if (!strcmp(argv[r], "--output-dir") && r + 1 < argc) {
				params->path_output_dir = argv[r + 1];
				r += 2;
			}
			else if (!strcmp(argv[r], "--no-scale")) {
				params->scale_est = false;
				r += 1;
			}
			else if (!strcmp(argv[r], "--verbose-level") && r + 1 < argc) {
				params->verbose_level = std::atoi(argv[r + 1]);
				r += 2;
			}
			else if (!strcmp(argv[r], "--detection-epsilon-ratio") && r + 1 < argc) {
				params->detection_epsilon_ratio = std::atof(argv[r + 1]);
				r += 2;
			}
			else if (!strcmp(argv[r], "--detection-normal-threshold") && r + 1 < argc) {
				params->detection_normal_threshold = std::atof(argv[r + 1]);
				r += 2;
			}
			else if (!strcmp(argv[r], "--detection-knn") && r + 1 < argc) {
				params->detection_knn = std::atoi(argv[r + 1]);
				r += 2;
			}
			else if (!strcmp(argv[r], "--detection-min-points") && r + 1 < argc) {
				params->detection_min_points = std::atoi(argv[r + 1]);
				r += 2;
			}
			else if (!strcmp(argv[r], "--num-pts") && r + 1 < argc) {
				params->nbq = std::atoi(argv[r + 1]);
				r += 2;
			}
			else if (!strcmp(argv[r], "--help")) {
				help(); exit(0);
			}
			else {
				std::cout << "What's this ? " << argv[r] << std::endl;
				help(); return false;
			}
		}
		return true;
	}

	
	void help()
	{
	std::cout << "Registration.exe. Description of the options : ..." << std::endl;
	}
};
