/////////////////////////////////////////////////
//                                             //
//  3D Alpha Shapes for Collision Detection    //
//  Graphical User Interface                   //
//					        //
//   @author Cédric Portaneri, Pierre Alliez   //
//                                             //
/////////////////////////////////////////////////

#include <QApplication>
#include <QtOpenGL>
#include <CGAL/config.h>
#include <CGAL/Qt/resources.h>
#include <CGAL/version_macros.h>

#include "types.h"
#include "window.h"

int main(int argc, char **argv)
{ 
	srand(0);
	QApplication app(argc, argv);
	app.setOrganizationDomain("inria.fr"); 
	app.setOrganizationName("Inria");
	app.setApplicationName("Registration demo");
#if (QT_VERSION >= QT_VERSION_CHECK(5, 3, 0))
	app.setAttribute(Qt::AA_UseDesktopOpenGL);
#endif
	// Import resources from libCGALQt (Qt5).
	CGAL_QT_INIT_RESOURCES;
	
	MainWindow gui;
	gui.show();
	
    std::cout << "CGAL version used : " << CGAL_VERSION_MAJOR << "." 
										<< CGAL_VERSION_MINOR << "." 
										<< CGAL_VERSION_PATCH << "\n";	
    std::cout << "QT5 version used : " << qVersion() << "\n";
    std::cout << "OpenGL version used : " << glGetString(GL_VERSION) << "\n";
	return app.exec();
}
