#ifndef _MAIN_WINDOW_
#define _MAIN_WINDOW_

#include "ui_viewer.h"
#include <CGAL/Qt/DemosMainWindow.h>

class QDragEnterEvent;
class QDropEvent;

class Viewer;
class Scene;

namespace Ui {
	class MainWindow;
}

class MainWindow : public CGAL::Qt::DemosMainWindow
{
	Q_OBJECT
private:
	Ui::MainWindow* ui;

	Viewer* m_pViewer;
	Scene* m_pScene;
    
public:
	MainWindow(QWidget* parent = 0);
	~MainWindow();
    
    public slots:
    void open(QString filename);
    void setAddKeyFrameKeyboardModifiers(Qt::KeyboardModifiers);
    
    protected slots:    
    // settings
    void quit();
    void readSettings();
    void writeSettings();
    
    // drag & drop
    void dropEvent(QDropEvent *event);
    void closeEvent(QCloseEvent *event);
    void dragEnterEvent(QDragEnterEvent *event);
    
    // file menu
    void on_actionLoad_input_file_triggered();
    void on_actionUnload_all_triggered();
    void on_actionCopy_snapshot_triggered();
    void on_actionSave_snapshot_triggered();

   
    // view menu
    void on_actionView_input_points_triggered();
    void on_actionView_input_polyhedron_triggered();
    void on_actionView_cut_plane_sdf_triggered();
    void on_actionView_cut_plane_gradient_triggered();
    void on_actionView_extracted_shapes_triggered();
    void on_actionView_transform_points_triggered();
    
    // algorithm menu
    void on_actionExtract_planes_from_point_cloud_triggered();
    void on_actionDistance_function_to_facets_triggered();
    void on_actionRegister_points_to_poyhedron_triggered();
};

#endif // ifndef _MAIN_WINDOW_
